<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>Soprano.Inference.InferenceModel</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>InferenceModel Class Reference</h1>
<code>from PyKDE4.soprano import *</code>
<p>
Inherits: <a href="../soprano/Soprano.FilterModel.html">Soprano.FilterModel</a> &#x2192; <a href="../soprano/Soprano.Model.html">Soprano.Model</a> &#x2192; <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a><br />

Namespace: Soprano::Inference<br />
<h2>Detailed Description</h2>

<p>\class InferenceModel inferencemodel.h Soprano/Inference/InferenceModel
</p>
<p>
The Soprano Inference Model provides a simple forward chaining inference engine
which uses the underlying parent model itself to store status information.
</p>
<p>
The InferenceModel does perfect inference which means that removing of statements is supported
and results in a perfect update of the infered statements. There is only one exception:
If a model contains two statements in different named graphs that both have the same subject,
predicate, and object and trigger one rule then if one of these statements is removed the
infered statements are removed, too, although the second statement would still make the infered
one valid. This situation gets resolved once the same rule is triggered again by some other
added statement or performInference gets called.
</p>
<p>
The inference is performed based on rules which are stored in Rule instances.
Rules can be created manually or parsed using a RuleParser.
</p>
<p>
<b>The inference engine works roughly as follows:</b>
</p>
<p>
Whenever a new statement is added it is compared to each rule to check if it could trigger this rule.
Then if it could trigger a rule this rule is applied to the whole model.
</p>
<p>
If a rule produces a new infered statement the following data is created:
<li> named graph A containing the infered statements </li>
<li> the statements that triggered the rule are stored in named graph sil:InferenceMetadata as </li>
source statements of A (sil:sourceStatement). The inference model supports two ways of storing
source statements: plain and compressed (see setCompressedSourceStatements).
</p>
<p>
Thus, when removing a statement it can easily be checked if this statement had been used to
infer another one by querying all named graphs that have this statement as a source statement.
</p>
<p>

<dl class="author" compact><dt><b>Author:</b></dt><dd> Sebastian Trueg &lt;trueg@kde.org&gt; </dd></dl>
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189034444">__init__</a> (self, <a href="../soprano/Soprano.Model.html">Soprano.Model</a> parent)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj164580844">addRule</a> (self, Soprano.Inference.Rule a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189033740">addStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj186540940">clearInference</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj164579020">performInference</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189033420">removeAllStatements</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">Soprano.Error.ErrorCode&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj189032556">removeStatement</a> (self, <a href="../soprano/Soprano.Statement.html">Soprano.Statement</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj177033420">setCompressedSourceStatements</a> (self, bool b)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj188963116">setOptimizedQueriesEnabled</a> (self, bool b)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj174863180">setRules</a> (self, [Soprano::Inference::Rule] rules)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj189034444"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Model.html">Soprano.Model</a>&nbsp;</td>
<td class="paramname"><em>parent</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj164580844"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> addRule</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">Soprano.Inference.Rule&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Add an inference rule to the set of rules.
This method will not trigger any inference action. If inference
is necessary call performInference() after adding the new rules.
</p></div></div><a class="anchor" name="obj189033740"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode addStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Add a new statement to the model. Inferencing will be done directly.
Inferenced statements are stored in additional named graphs.
</p></div></div><a class="anchor" name="obj186540940"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> clearInference</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Removes all statements infered by this model.
This can be useful if the parent model has been changed without informing
the inference model and statements have been removed.
</p></div></div><a class="anchor" name="obj164579020"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> performInference</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Normally inferencing is done once new statements are added to the model or
statements are removed. This method performs inferencing on the whole model.
It is useful for initializing a model that already contains statements or
update the model if it has been modified bypassing this filter model.
</p>
<p>
Tha latter can easily be done by connecting the Model.statementsAdded and
Model.statementsRemoved signals to this slot.
</p></div></div><a class="anchor" name="obj189033420"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode removeAllStatements</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Remove statements from the model.
</p></div></div><a class="anchor" name="obj189032556"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">Soprano.Error.ErrorCode removeStatement</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../soprano/Soprano.Statement.html">Soprano.Statement</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Remove one statement from the model.
</p></div></div><a class="anchor" name="obj177033420"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setCompressedSourceStatements</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>b</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>If compressed statements are enabled source statements are stored compressed
in one literal value. Otherwise source statements are stored using rdf:subject,
rdf:predicate, rdf:object, and sil:context. Non-compressed statements are much
cleaner from an ontology design point of view while compressed statements take
much less space.
</p>
<p>
By default comressed source statements are enabled.
</p>
<p>
This method exists mainly for historical reasons and there normally is no need
to call it. Compressed statements should work well for most users.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>b</em>&nbsp;</td><td> If true compressed source statements are enabled (the default).
</td></tr>
</table></dl>
<p>
</p></div></div><a class="anchor" name="obj188963116"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setOptimizedQueriesEnabled</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>b</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>If the storage backend supports joined SPARQL queries via UNION
it makes sense to enable this.
</p>
<p>
</p><dl compact><dt><b>Parameters:</b></dt><dd>
<table border="0" cellspacing="2" cellpadding="0">
<tr><td></td><td valign="top"><em>b</em>&nbsp;</td><td> If true InferenceModel will use optimized queries for
the inference during addStatement. This will speed up the
process quite a lot as matching rules are only applied to the new statement.
This flag has no influcence on performInference() though.
</td></tr>
</table></dl>
<p> The default is to disable the optimized queries since the default
soprano redland backend does not support UNION.
</p></div></div><a class="anchor" name="obj174863180"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setRules</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[Soprano::Inference::Rule]&nbsp;</td>
<td class="paramname"><em>rules</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Set the inference rules to be used.
This method will not trigger any inference action. If inference
is necessary call performInference() after adding the new rules.
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
